;________________________________________________________________________
;
;                                  I 2 C . A S M
;________________________________________________________________________
;
; Sending simple I2C instructions
; by Byon Garrabrant  N6BG  byon@mail.com  Aug 98
;________________________________________________________________________
;
	cblock				; variables
		I2C_send_byte
		I2C_send_byte_count
	endc

#define	I2C_DATA	PORTB, 0
#define	I2C_CLOCK	PORTB, 1
;________________________________________________________________________

I2C_Init
	bsf	STATUS, RP0		; Select Bank 1
	bcf	I2C_DATA		; make data an output
	bcf	I2C_CLOCK		; make clock an output
	bcf	STATUS, RP0		; Select Bank 0
	goto	I2C_Stop
;________________________________________________________________________

I2C_Clock_High
	bsf	I2C_CLOCK		; clock high
	goto	I2C_Delay		; and delay

I2C_Clock_Low
	bcf	I2C_CLOCK		; clock low
;	goto	I2C_Delay		; and delay

I2C_Delay				; delays 14 instructuions (5.6us)
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	return
;________________________________________________________________________

I2C_Start
	bcf	I2C_DATA		; data low
	goto	I2C_Clock_Low		; clock low

I2C_Stop
	bcf	I2C_DATA		; be sure the data is low
	call	I2C_Clock_High		; clock high
	bsf	I2C_DATA		; data high
	return
;________________________________________________________________________

I2C_Bit
	bsf	I2C_DATA		; assume data high
	skpc
	 bcf	I2C_DATA		; data low
	call	I2C_Clock_High		; clock high
	goto	I2C_Clock_Low		; clock low
;________________________________________________________________________

I2C_Send_Byte
	movwf	I2C_send_byte		; save the byte
	movlw	8
	movwf	I2C_send_byte_count	; 8 bits per byte
I2C_Send_Byte_Loop
	rlf	I2C_send_byte, F	; rotate data
	call	I2C_Bit			; and send
	decfsz	I2C_send_byte_count, F	; check bit count
	 goto	I2C_Send_Byte_Loop	; if not done, loop back
	goto	I2C_Bit			; false ack and end
;________________________________________________________________________
